package com.ekexiu.project.bridge.collect;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

import org.jfw.apt.orm.annotation.dao.Batch;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectList;
import org.jfw.apt.orm.annotation.dao.param.Alias;
import org.jfw.apt.orm.annotation.dao.param.GtEq;
import org.jfw.apt.orm.annotation.dao.param.LtEq;

@DAO
public interface CollectDao {

	@Insert
	@Batch
	int[] insert(Connection con,List<WaveDataItem> items)throws SQLException;
	
	@SelectList
	@OrderBy("ORDER BY CTIME,DIC,CID")
	List<WaveDataItem> query(Connection con,String seq,@Alias("ctime") @GtEq String btime,@Alias("ctime") @LtEq String etime)throws SQLException;
	
	@SelectList
	@OrderBy("ORDER BY CTIME,CID")
	List<WaveDataItem> query(Connection con,String seq,int did,@Alias("ctime") @GtEq String btime,@Alias("ctime") @LtEq String etime)throws SQLException;
	
	@SelectList
	@OrderBy("ORDER BY CTIME")
	List<WaveDataItem> query(Connection con,String seq,int did,int cid,@Alias("ctime") @GtEq String btime,@Alias("ctime") @LtEq String etime)throws SQLException;
	
	@Insert
	int insert(Connection con,AlarmMsg msg)throws SQLException;
	@Insert
	@Batch
	int[] insert(Connection con,AlarmDataItem[] items)throws SQLException;
}
