package com.ekexiu.project.bridge.collect;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;
import java.util.Map;

import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.param.JdbcConn;


@Path("/collect")
public class CollectService {

	private Map<String, List<WaveDataItem>> waveCache;

	@Autowrie
	private CollectDao collectDao;

	public CollectDao getCollectDao() {
		return collectDao;
	}

	public void setCollectDao(CollectDao collectDao) {
		this.collectDao = collectDao;
	}

	public Map<String, List<WaveDataItem>> getWaveCache() {
		return waveCache;
	}

	public void setWaveCache(Map<String, List<WaveDataItem>> waveCache) {
		this.waveCache = waveCache;
	}

	@Get
	@Path("/wave/curr")
	public List<WaveDataItem> wave(String seq) {
		List<WaveDataItem> ret = null;
		synchronized (this.waveCache) {
			ret = waveCache.get(seq);
		}
		return ret;
	}
	
	@Get
	@Path("/wave/node/day")
	public List<WaveDataItem> waveByDay(@JdbcConn Connection con,String seq,String day)throws SQLException{
		return this.collectDao.query(con, seq, day+"000000", day+"235959");
	}
	
	@Get
	@Path("/wave/node/time")
	public List<WaveDataItem> waveByDay(@JdbcConn Connection con,String seq,String begin,String end)throws SQLException{
		return this.collectDao.query(con, seq, begin,end);
	}
	@Get
	@Path("/wave/box/time")
	public List<WaveDataItem> waveByDay(@JdbcConn Connection con,String seq,int box,String begin,String end)throws SQLException{
		return this.collectDao.query(con, seq,box, begin,end);
	}
	@Get
	@Path("/wave/channel/time")
	public List<WaveDataItem> waveByDay(@JdbcConn Connection con,String seq,int box,int channel,String begin,String end)throws SQLException{
		return this.collectDao.query(con, seq,box,channel,begin,end);
	}
	
	
}
