package com.ekexiu.project.bridge.resource.dao;

import com.ekexiu.project.bridge.resource.po.Bridge;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.IncludeFixSet;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.SetSentence;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.PageSelect;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectOne;
import org.jfw.apt.orm.annotation.dao.method.operator.Update;
import org.jfw.apt.orm.annotation.dao.method.operator.UpdateWith;
import org.jfw.apt.orm.annotation.dao.param.Like;
import org.jfw.apt.orm.annotation.dao.param.Set;
import org.jfw.apt.orm.annotation.dao.param.SqlColumn;
import org.jfw.apt.orm.core.defaultImpl.StringHandler;
import org.jfw.util.PageQueryResult;

import java.sql.Connection;
import java.sql.SQLException;

/**
 * Created by TT on 2018/8/8.
 */
@DAO
public interface BridgeDao {

    @Insert
    int insert(Connection con, Bridge bridge)throws SQLException;

    @UpdateWith
    @From(Bridge.class)
    @SetSentence("active = '0'")
    @IncludeFixSet("modifyTime")
    int logicDelete(Connection con, @Set String modifier, String id) throws SQLException;

    @Update
    int update(Connection con, Bridge bridge) throws SQLException;

    @SelectOne
    @Nullable
    Bridge query(Connection con, String id) throws SQLException;

    @PageSelect
    @OrderBy("ORDER BY CODE")
    PageQueryResult<Bridge> pageQuery(Connection con, @Nullable Boolean active, @Nullable @Like String name, @Nullable String code, int pageSize, int pageNo) throws SQLException;

    @PageSelect
    @OrderBy("ORDER BY CODE")
    PageQueryResult<Bridge> pageQuery(Connection con, @Nullable Boolean active, @SqlColumn(handlerClass = StringHandler.class, value = "ID IN(SELECT BCODE FROM USER_BRIDGE WHERE UID=?)") String uid, int pageSize, int pageNo) throws SQLException;
}
