package com.ekexiu.project.bridge.servlet;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.lang.reflect.Type;
import java.sql.Connection;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.sql.DataSource;

import org.jfw.util.ConstData;
import org.jfw.util.context.JfwAppContext;
import org.jfw.util.io.IoUtil;
import org.jfw.util.jdbc.JdbcUtil;
import org.jfw.util.json.JsonService;
import org.jfw.util.reflect.TypeReference;

import com.ekexiu.project.bridge.collect.AlarmDataItem;
import com.ekexiu.project.bridge.collect.AlarmMsg;
import com.ekexiu.project.bridge.collect.CollectDao;
import com.ekexiu.project.bridge.collect.CollectService;
import com.ekexiu.project.bridge.collect.WaveDataItem;
import com.ekexiu.project.bridge.resource.po.Bridge;
import com.ekexiu.project.bridge.system.dao.UserDao;
import com.ekexiu.project.bridge.system.po.User;

public class AlarmDataServlet extends HttpServlet {
	private static final long serialVersionUID = 4989044137656168797L;


	public static Type DATA_TYPE=new TypeReference<Map<Object,Object>>(){}.getType();

	private DataSource dataSource;
	private CollectDao collectDao;
	private UserDao userDao;

	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		response.sendError(400);
	}

	@SuppressWarnings({ "rawtypes", "unchecked" })
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		InputStream in = request.getInputStream();
		 List<AlarmDataItem> items = new LinkedList<AlarmDataItem>();
		final AlarmMsg msg = new AlarmMsg();
		StringBuilder sb = new StringBuilder();
		List<Object> datas = null;
		try {
			byte[] buf = new byte[8192];
			IoUtil.copy(in, baos, buf);
			Map<Object,Object> map = JsonService.fromJson(new String(baos.toByteArray(), ConstData.UTF8), DATA_TYPE);
			Object tmpObj = map.get("node_id");
			if(tmpObj != null && tmpObj instanceof String){
				msg.setSeq((String)tmpObj);
				tmpObj = map.get("alarm_no");
				if(tmpObj != null && tmpObj instanceof String){
					msg.setAid((String)tmpObj);
					tmpObj = map.get("box_id");
					if(tmpObj != null && tmpObj instanceof String){
						try{
							msg.setDevice(Integer.parseInt((String)tmpObj));
							tmpObj = map.get("data");
							if(tmpObj != null && tmpObj instanceof List){
								datas=(List<Object>) tmpObj;
							}
						}catch(Exception e){
						}
					}
				}
			}
			if(datas!=null){
				for(Object obj:datas){
					AlarmDataItem item = new AlarmDataItem();
					if(obj !=null && obj instanceof Map){
						map = (Map<Object,Object>)obj;
						item.setId(msg.getAid());
						tmpObj = map.get("channel_id");
						if(tmpObj != null && tmpObj instanceof String){
							try{
								item.setSeq(Integer.parseInt((String)tmpObj));
							}catch(Exception e){
								items.clear();
								break;
							}
						}else{
							items.clear();
							break;
						}
						tmpObj = map.get("start_time");
						if(tmpObj != null && tmpObj instanceof String){
								item.setStime((String)tmpObj);
						}else{
							items.clear();
							break;
						}
						tmpObj = map.get("alarm_time");
						if(tmpObj != null && tmpObj instanceof String){
								item.setStime((String)tmpObj);
						}else{
							items.clear();
							break;
						}
						
						sb.setLength(0);
						tmpObj = map.get("value");
						if(tmpObj != null && tmpObj instanceof List){
							for(Object val:((List)tmpObj)){
								sb.append(val.toString()).append(",");
							}
						}
						if(sb.length()>0){
							item.setData(sb.substring(0,sb.length()-1));
						}else{
							items.clear();
							break;
						}
					}
				}
			}
		} finally {
			in.close();
		}
		
		Connection con = this.dataSource.getConnection();
		try{
		//	final Bridge bridge = this
			
		//	List<User> users = this.userDao.queryByBridgeCode(con, msg.getSeq(), true);
			
			
		}finally{
			JdbcUtil.close(con);
		}
		
		response.setDateHeader("Expires", 0);
		response.setHeader("Cache-Control", "no-store, no-cache, must-revalidate");
		response.addHeader("Cache-Control", "post-check=0, pre-check=0");
		response.setHeader("Pragma", "no-cache");
		if (null == request.getCharacterEncoding()) {
			request.setCharacterEncoding("UTF-8");
			request.setCharacterEncoding("UTF-8");
		}
		response.setContentType("application/json");
		java.io.PrintWriter out = response.getWriter();
		if (items.isEmpty()) {
			out.write("{\"status\":0,}");
			return;
		}
		out.write("{\"status\":1,}");
		synchronized (DATA_CACHE) {
			DATA_CACHE.put(items.get(0).getSeq(), items);
		}
		JfwAppContext.getScheduledExecutorService().execute(new Runnable() {
			@Override
			public void run() {
				try {
					Connection con = dataSource.getConnection();
					try {
						collectDao.insert(con, items);
						con.commit();
					} catch (SQLException e) {
						con.rollback();
					} finally {
						con.close();
					}
				} catch (Throwable thr) {
				}

			}
		});
	}


	@Override
	public void init() throws ServletException {
		this.dataSource = JfwAppContext.getDataSource();
		if (this.dataSource == null) {
			throw new ServletException("not found datasource");
		}
		this.collectDao = (CollectDao) JfwAppContext.getBeanFactory().getBean("com_ekexiu_project_bridge_collect_CollectDao");
		if (this.dataSource == null) {
			throw new ServletException("not found collectDao");
		}
		this.userDao = (UserDao) JfwAppContext.getBeanFactory().getBean("com_ekexiu_project_bridge_system_dao_UserDao");
		if (userDao == null) {
			throw new ServletException("not found userDao");
		}
	}
}