package com.ekexiu.project.bridge.system.dao;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.IncludeFixSet;
import org.jfw.apt.orm.annotation.dao.method.SetSentence;
import org.jfw.apt.orm.annotation.dao.method.Where;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectList;
import org.jfw.apt.orm.annotation.dao.method.operator.UpdateWith;
import org.jfw.apt.orm.annotation.dao.param.Set;

import com.ekexiu.project.bridge.system.po.DictItem;

@DAO
public interface DictDao {

	@SelectList
	List<DictItem> query(Connection con) throws SQLException;

	@Insert
	int insert(Connection con, DictItem dict) throws SQLException;

	@UpdateWith
	@From(DictItem.class)
	@Where("ACTIVE = '1' AND READONLY <> '1'")
	@SetSentence("ACTIVE='0'")
	@IncludeFixSet
	int disable(Connection con, String dictCode, String code) throws SQLException;

	
	@UpdateWith
	@From(DictItem.class)
	@Where("ACTIVE = '1' AND READONLY <> '1'")
	int update(Connection con, @Nullable @Set String bcode, @Set String caption, @Nullable @Set String fullCaption, @Set @Nullable String shortCut,
			@Nullable @Set String remark, String code, String dictCode) throws SQLException;

}
