package com.ekexiu.project.bridge.system.dao;

import com.ekexiu.project.bridge.system.po.Notice;
import com.ekexiu.project.bridge.system.po.User;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.Dynamic;
import org.jfw.apt.orm.annotation.dao.method.Exclude;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.IncludeFixSet;
import org.jfw.apt.orm.annotation.dao.method.SetSentence;
import org.jfw.apt.orm.annotation.dao.method.Where;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.PageSelect;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectOne;
import org.jfw.apt.orm.annotation.dao.method.operator.Update;
import org.jfw.apt.orm.annotation.dao.method.operator.UpdateWith;
import org.jfw.apt.orm.annotation.dao.param.Like;
import org.jfw.apt.orm.annotation.dao.param.Set;
import org.jfw.util.PageQueryResult;

import java.sql.Connection;
import java.sql.SQLException;

/**
 * Created by TT on 2018/8/7.
 */
@DAO
public interface UserDao {

    @Nullable
    @SelectOne
    User query(Connection con, String id)throws SQLException;

    @Nullable
    @SelectOne
    @Where("active = '1'")
    User login(Connection con, String account,String passwd) throws SQLException;

    @Insert
    int insert(Connection con, User user) throws SQLException;

    @Update
    @Exclude("passwd")
    @Dynamic
    int update(Connection con, User user) throws SQLException;
    @UpdateWith
    @From(User.class)
    int updatePasswdWithMobile(Connection con,@Set String passwd,String account) throws SQLException;

    @UpdateWith
    @From(User.class)
    @SetSentence("active = '0'")
    int ban(Connection con,@Set String modifier, String id) throws SQLException;

    @PageSelect
    @Where("active = '1'")
    PageQueryResult<User> pageQuery(Connection con, @Nullable String account, @Nullable @Like String name, @Nullable @Like String comp, int pageSize, int pageNo) throws SQLException;

    @UpdateWith
    @From(User.class)
    int changePw(Connection con, @Set String passwd, String id) throws SQLException;

    @UpdateWith
    @From(Notice.class)
    @IncludeFixSet("modifyTime")
    int updateNotice(Connection con, @Set String cnt,@Set String modifier) throws SQLException;

    @Nullable
    @SelectOne
    User queryByAccount(Connection con,String account)throws SQLException;
}
