package com.ekexiu.project.bridge.system.po;

import org.jfw.apt.orm.annotation.entry.Column;
import org.jfw.apt.orm.annotation.entry.PrimaryKey;
import org.jfw.apt.orm.annotation.entry.Table;
import org.jfw.apt.orm.annotation.entry.Unique;
import org.jfw.apt.orm.annotation.entry.Uniques;
import org.jfw.apt.orm.core.defaultImpl.StringHandler;
import org.jfw.apt.orm.core.enums.DE;

import com.ekexiu.project.bridge.base.po.BaseTable;

@PrimaryKey("id")
@Uniques({@Unique(clolumns="account",name="UC_LUSER_ACCOUNT")})
@Table(descp="用户表",value="LUSER")
public class User implements BaseTable {
	private String createTime;
	private String modifyTime;
	private String creator;
	private String modifier;
	
	private String id;
	private String name;
	private String account;
	private String comp;
	private String job;
	private String phone;
	private String email;
	private String remark;
	private String passwd;
	private int type;
	
	private boolean active;
	
	
	@Column(descp="是否可用",value=DE.boolean_de)
	public boolean isActive() {
		return active;
	}
	public void setActive(boolean active) {
		this.active = active;
	}
	@Column(descp="密码（MD5）",queryable=false,handlerClass = StringHandler.class,dbType = "TEXT")
	public String getPasswd() {
		return passwd;
	}
	public void setPasswd(String passwd) {
		this.passwd = passwd;
	}
	@Column(descp="用户ID",value =DE.id_32)
	public String getId() {
		return id;
	}
	public void setId(String id) {
		this.id = id;
	}
	@Column(descp="用户姓名",value =DE.text_de)
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	@Column(descp="用户帐号",value=DE.text_de)
	public String getAccount() {
		return account;
	}
	public void setAccount(String account) {
		this.account = account;
	}
	@Column(descp="用户所属单位",value=DE.text_de)
	public String getComp() {
		return comp;
	}
	public void setComp(String comp) {
		this.comp = comp;
	}
	@Column(value=DE.text_de,descp="用户职位")
	public String getJob() {
		return job;
	}
	public void setJob(String job) {
		this.job = job;
	}
	@Column(descp="联系电话",value=DE.Text_de)
	public String getPhone() {
		return phone;
	}
	public void setPhone(String phone) {
		this.phone = phone;
	}
	@Column(descp="联系邮件",value=DE.Text_de)
	public String getEmail() {
		return email;
	}
	public void setEmail(String email) {
		this.email = email;
	}
	@Column(descp="备注",value=DE.Text_de)
	public String getRemark() {
		return remark;
	}
	public void setRemark(String remark) {
		this.remark = remark;
	}
	@Column(descp="账户类型",value=DE.int_de)
	public int getType() {
		return type;
	}
	public void setType(int type) {
		this.type = type;
	}
	public String getCreateTime() {
		return createTime;
	}
	public void setCreateTime(String createTime) {
		this.createTime = createTime;
	}
	public String getModifyTime() {
		return modifyTime;
	}
	public void setModifyTime(String modifyTime) {
		this.modifyTime = modifyTime;
	}
	public String getCreator() {
		return creator;
	}
	public void setCreator(String creator) {
		this.creator = creator;
	}
	public String getModifier() {
		return modifier;
	}
	public void setModifier(String modifier) {
		this.modifier = modifier;
	}
	
	
	
}
